import expect, { createSpy } from 'expect';
import createOnChange from '../createOnChange';

describe('createOnChange', function () {
  it('should return a function', function () {
    expect(createOnChange()).toExist().toBeA('function');
  });

  it('should return a function that calls change with name and value', function () {
    var change = createSpy();
    var normalize = createSpy(function (value) {
      return 'normalized-' + value;
    }).andCallThrough();
    createOnChange(change, normalize)('bar');
    expect(normalize).toHaveBeenCalled().toHaveBeenCalledWith('bar');
    expect(change).toHaveBeenCalled().toHaveBeenCalledWith('normalized-bar');
  });
});